From 7a99cc9d3f95dbc5819770573e0edf0bb0d8a3de Mon Sep 17 00:00:00 2001
From: Sergey Fedorov <vital.had@gmail.com>
Date: Tue, 24 Feb 2026 14:39:58 +0800
Subject: [PATCH 1/6] Build with Qt4

---
 CMakeLists.txt                                | 182 +++--
 lang/CMakeLists.txt                           |   8 +-
 src/gui/AVThread.cpp                          |   3 +
 src/gui/AVThread.hpp                          |   9 +-
 src/gui/AboutWidget.cpp                       |  18 +-
 src/gui/AboutWidget.hpp                       |   6 +-
 src/gui/AddressBox.cpp                        |   4 +-
 src/gui/AddressDialog.hpp                     |   2 +-
 src/gui/Appearance.cpp                        |  41 +-
 src/gui/Appearance.hpp                        |   3 +-
 src/gui/AudioThr.cpp                          |  24 +-
 src/gui/AudioThr.hpp                          |   6 +-
 src/gui/CMakeLists.txt                        |  28 +-
 src/gui/DeintSettingsW.cpp                    |   2 +-
 src/gui/DeintSettingsW.hpp                    |   2 +-
 src/gui/DemuxerThr.cpp                        |  33 +-
 src/gui/DemuxerThr.hpp                        |   6 +-
 src/gui/EntryProperties.cpp                   |   2 +-
 src/gui/EntryProperties.hpp                   |   6 +-
 src/gui/InfoDock.cpp                          |   7 +-
 src/gui/InfoDock.hpp                          |   6 +-
 src/gui/KeyBindingsDialog.cpp                 |   5 +
 src/gui/Main.cpp                              | 277 ++++++--
 src/gui/Main.hpp                              |   6 +-
 src/gui/MainWidget.cpp                        | 631 +++++++++++++-----
 src/gui/MainWidget.hpp                        |  88 ++-
 src/gui/MenuBar.cpp                           |  25 +-
 src/gui/OSDSettingsW.cpp                      |  24 +-
 src/gui/OSDSettingsW.hpp                      |   5 +
 src/gui/PanGestureEventFilter.cpp             |   6 +
 src/gui/PlayClass.cpp                         |  77 ++-
 src/gui/PlayClass.hpp                         |  14 +-
 src/gui/PlaylistDock.cpp                      |  28 +-
 src/gui/PlaylistDock.hpp                      |   2 +-
 src/gui/PlaylistWidget.cpp                    |  64 +-
 src/gui/PlaylistWidget.hpp                    |  53 +-
 src/gui/SettingsWidget.cpp                    | 445 +++++++-----
 src/gui/SettingsWidget.hpp                    |  55 +-
 src/gui/ShortcutHandler.hpp                   |  14 +-
 src/gui/TagEditor.cpp                         |  15 +-
 src/gui/TagEditor.hpp                         |  12 +-
 src/gui/Unix/ScreenSaver.cpp                  |  25 +-
 src/gui/Updater.hpp                           |   2 +-
 src/gui/VideoAdjustmentW.cpp                  |  77 ++-
 src/gui/VideoAdjustmentW.hpp                  |  17 +-
 src/gui/VideoDock.cpp                         |  46 +-
 src/gui/VideoDock.hpp                         |  26 +-
 src/gui/VideoThr.cpp                          |  61 +-
 src/gui/VideoThr.hpp                          |  28 +-
 src/gui/Windows/PanGestureEventFilter.cpp     |   6 +-
 src/gui/macOS/QMPlay2MacExtensions.hpp        |   4 +-
 src/gui/macOS/QMPlay2MacExtensions.mm         | 142 ++--
 src/modules/ALSA/ALSA.hpp                     |  12 +-
 src/modules/ALSA/ALSAWriter.hpp               |  16 +-
 src/modules/AudioCD/AudioCD.hpp               |  14 +-
 src/modules/AudioCD/AudioCDDemux.cpp          |   4 +-
 src/modules/AudioCD/AudioCDDemux.hpp          |  28 +-
 src/modules/AudioFilters/AVAudioFilter.cpp    |   8 +-
 src/modules/AudioFilters/AVAudioFilter.hpp    |  16 +-
 src/modules/AudioFilters/AudioFilters.cpp     |  58 +-
 src/modules/AudioFilters/AudioFilters.hpp     |  17 +-
 src/modules/AudioFilters/BS2B.hpp             |  10 +-
 src/modules/AudioFilters/DysonCompressor.hpp  |  12 +-
 src/modules/AudioFilters/Echo.hpp             |   8 +-
 src/modules/AudioFilters/Equalizer.cpp        |   3 +
 src/modules/AudioFilters/Equalizer.hpp        |  22 +-
 src/modules/AudioFilters/EqualizerGUI.cpp     |   6 +-
 src/modules/AudioFilters/EqualizerGUI.hpp     |  12 +-
 src/modules/AudioFilters/PhaseReverse.hpp     |   8 +-
 src/modules/AudioFilters/SwapStereo.hpp       |   8 +-
 src/modules/AudioFilters/VoiceRemoval.hpp     |   8 +-
 src/modules/CUVID/Cuvid.hpp                   |  12 +-
 src/modules/CUVID/CuvidDec.hpp                |  18 +-
 src/modules/CUVID/CuvidOpenGL.cpp             |   2 +-
 src/modules/CUVID/CuvidOpenGL.hpp             |  16 +-
 src/modules/CUVID/CuvidVulkan.hpp             |  10 +-
 src/modules/Chiptune/Chiptune.hpp             |  12 +-
 src/modules/Chiptune/GME.hpp                  |  24 +-
 src/modules/Chiptune/SIDPlay.hpp              |  24 +-
 src/modules/DirectX/DirectDraw.hpp            |  26 +-
 src/modules/DirectX/DirectX.hpp               |  12 +-
 src/modules/Extensions/CMakeLists.txt         |   1 +
 src/modules/Extensions/Downloader.cpp         | 177 +++--
 src/modules/Extensions/Downloader.hpp         |  41 +-
 src/modules/Extensions/Extensions.hpp         |  12 +-
 src/modules/Extensions/LastFM.cpp             |  77 ++-
 src/modules/Extensions/LastFM.hpp             |   9 +-
 src/modules/Extensions/Lyrics.cpp             |  59 +-
 src/modules/Extensions/Lyrics.hpp             |   6 +-
 src/modules/Extensions/MPRIS2.cpp             |   2 +-
 src/modules/Extensions/MPRIS2.hpp             |  13 +-
 src/modules/Extensions/MediaBrowser.cpp       |  10 +-
 src/modules/Extensions/MediaBrowser.hpp       |  16 +-
 src/modules/Extensions/OpenSubtitles.cpp      | 508 ++++++++------
 src/modules/Extensions/OpenSubtitles.hpp      |  43 +-
 src/modules/Extensions/Radio.cpp              | 100 ++-
 src/modules/Extensions/Radio.hpp              |  25 +-
 .../Extensions/Radio/RadioBrowserModel.cpp    |  22 +-
 .../Extensions/Radio/RadioBrowserModel.hpp    |  18 +-
 src/modules/Extensions/YouTube.cpp            | 353 ++++++----
 src/modules/Extensions/YouTube.hpp            |  35 +-
 src/modules/FFmpeg/D3D11VAVulkan.hpp          |   8 +-
 src/modules/FFmpeg/DXVA2OpenGL.cpp            |  16 +-
 src/modules/FFmpeg/DXVA2OpenGL.hpp            |  20 +-
 src/modules/FFmpeg/FFCommon.cpp               |   8 +-
 src/modules/FFmpeg/FFDec.hpp                  |   4 +-
 src/modules/FFmpeg/FFDecD3D11VA.hpp           |  10 +-
 src/modules/FFmpeg/FFDecDXVA2.hpp             |  10 +-
 src/modules/FFmpeg/FFDecHWAccel.hpp           |   6 +-
 src/modules/FFmpeg/FFDecSW.cpp                |  12 +-
 src/modules/FFmpeg/FFDecSW.hpp                |  24 +-
 src/modules/FFmpeg/FFDecVAAPI.cpp             |   2 +-
 src/modules/FFmpeg/FFDecVAAPI.hpp             |  12 +-
 src/modules/FFmpeg/FFDecVTB.hpp               |   8 +-
 src/modules/FFmpeg/FFDecVkVideo.hpp           |  10 +-
 src/modules/FFmpeg/FFDemux.cpp                |  28 +-
 src/modules/FFmpeg/FFDemux.hpp                |  44 +-
 src/modules/FFmpeg/FFReader.cpp               |   2 +-
 src/modules/FFmpeg/FFReader.hpp               |  24 +-
 src/modules/FFmpeg/FFmpeg.cpp                 |  28 +-
 src/modules/FFmpeg/FFmpeg.hpp                 |  14 +-
 src/modules/FFmpeg/FormatContext.cpp          |  14 +-
 src/modules/FFmpeg/VAAPI.cpp                  |  10 +-
 src/modules/FFmpeg/VAAPI.hpp                  |  41 +-
 src/modules/FFmpeg/VAAPIOpenGL.cpp            |   5 +-
 src/modules/FFmpeg/VAAPIOpenGL.hpp            |  16 +-
 src/modules/FFmpeg/VAAPIVulkan.cpp            |   2 +-
 src/modules/FFmpeg/VAAPIVulkan.hpp            |  10 +-
 src/modules/FFmpeg/VTBOpenGL.cpp              |   2 +-
 src/modules/FFmpeg/VTBOpenGL.hpp              |  20 +-
 src/modules/FFmpeg/VkVideoVulkan.hpp          |  12 +-
 .../FileAssociation/FileAssociation.hpp       |  12 +-
 src/modules/Inputs/Inputs.cpp                 |   2 +-
 src/modules/Inputs/Inputs.hpp                 |  18 +-
 src/modules/Inputs/PCM.hpp                    |  20 +-
 src/modules/Inputs/ToneGenerator.cpp          |  18 +-
 src/modules/Inputs/ToneGenerator.hpp          |  24 +-
 src/modules/Notify/Notify.hpp                 |  12 +-
 src/modules/Notify/NotifyExtension.cpp        |   2 +-
 src/modules/Notify/NotifyExtension.hpp        |   9 +-
 src/modules/OpenMPT/OpenMPT.cpp               |  17 +-
 src/modules/OpenMPT/OpenMPT.hpp               |  25 +-
 src/modules/OpenMPT/OpenMPTDemux.cpp          |   4 +-
 src/modules/OpenMPT/OpenMPTDemux.hpp          |  28 +-
 src/modules/OpenMPT/OpenMPTVisBase.cpp        |   2 +-
 src/modules/OpenMPT/OpenMPTVisPatterns.cpp    |  10 +
 src/modules/OpenMPT/OpenMPTVisPatterns.hpp    |   4 +-
 src/modules/OpenMPT/OpenMPTVisSamples.cpp     |   9 +-
 src/modules/OpenMPT/OpenMPTVisSamples.hpp     |   4 +-
 src/modules/OpenSLES/OpenSLESWriter.hpp       |  16 +-
 src/modules/PipeWire/PipeWire.hpp             |  12 +-
 src/modules/PipeWire/PipeWireWriter.hpp       |  16 +-
 src/modules/Playlists/M3U.cpp                 |   8 +-
 src/modules/Playlists/M3U.hpp                 |   6 +-
 src/modules/Playlists/PLS.cpp                 |   4 +-
 src/modules/Playlists/PLS.hpp                 |   6 +-
 src/modules/Playlists/Playlists.hpp           |  12 +-
 src/modules/Playlists/XSPF.cpp                |  24 +-
 src/modules/Playlists/XSPF.hpp                |   6 +-
 .../3rdparty/CoreAudio/AudioDevice.h          |   7 +-
 src/modules/PortAudio/PortAudio.cpp           |   8 +-
 src/modules/PortAudio/PortAudio.hpp           |  14 +-
 src/modules/PortAudio/PortAudioWriter.cpp     |  16 +-
 src/modules/PortAudio/PortAudioWriter.hpp     |  38 +-
 src/modules/PulseAudio/PulseAudio.hpp         |  12 +-
 src/modules/PulseAudio/PulseAudioWriter.hpp   |  14 +-
 src/modules/QPainter/QPainter.hpp             |  12 +-
 src/modules/QPainter/QPainterWriter.cpp       |  27 +-
 src/modules/QPainter/QPainterWriter.hpp       |  27 +-
 src/modules/Subtitles/Classic.cpp             |  34 +-
 src/modules/Subtitles/Classic.hpp             |   4 +-
 src/modules/Subtitles/SRT.cpp                 |   4 +-
 src/modules/Subtitles/SRT.hpp                 |   4 +-
 src/modules/Subtitles/Subtitles.hpp           |  12 +-
 src/modules/VideoFilters/BlendDeint.hpp       |   6 +-
 src/modules/VideoFilters/BobDeint.hpp         |   6 +-
 src/modules/VideoFilters/DiscardDeint.hpp     |   6 +-
 src/modules/VideoFilters/FPSDoubler.cpp       |   6 +-
 src/modules/VideoFilters/FPSDoubler.hpp       |   8 +-
 src/modules/VideoFilters/MotionBlur.hpp       |   6 +-
 src/modules/VideoFilters/VFilters.cpp         |   5 +
 src/modules/VideoFilters/VFilters.hpp         |  18 +-
 src/modules/VideoFilters/YadifDeint.cpp       |  12 +-
 src/modules/VideoFilters/YadifDeint.hpp       |   6 +-
 src/modules/Visualizations/FFTSpectrum.hpp    |  26 +-
 src/modules/Visualizations/SimpleVis.hpp      |  26 +-
 src/modules/Visualizations/VisWidget.cpp      |  10 +-
 src/modules/Visualizations/VisWidget.hpp      |   6 +-
 src/modules/Visualizations/Visualizations.cpp |   2 +-
 src/modules/Visualizations/Visualizations.hpp |  12 +-
 src/modules/XVideo/XVideo.cpp                 |  16 +-
 src/modules/XVideo/XVideo.hpp                 |  12 +-
 src/modules/XVideo/XVideoWriter.hpp           |  24 +-
 src/qmplay2/CMakeLists.txt                    |  93 +--
 src/qmplay2/ChapterProgramInfo.hpp            |   2 +
 src/qmplay2/ColorButton.cpp                   |   7 +-
 src/qmplay2/ColorButton.hpp                   |   7 +-
 src/qmplay2/CommonJS.cpp                      |  66 +-
 src/qmplay2/CommonJS.hpp                      |  12 +
 src/qmplay2/Decoder.cpp                       |  10 +-
 src/qmplay2/DeintHWPrepareFilter.cpp          |   2 +-
 src/qmplay2/DeintHWPrepareFilter.hpp          |   4 +-
 src/qmplay2/Demuxer.cpp                       |   2 +-
 src/qmplay2/DockWidget.cpp                    |  45 +-
 src/qmplay2/DockWidget.hpp                    |  11 +-
 src/qmplay2/Functions.cpp                     | 180 +++--
 src/qmplay2/Functions.hpp                     |   4 +-
 src/qmplay2/GPUInstance.cpp                   |  16 +-
 src/qmplay2/IPC.hpp                           |  12 +-
 src/qmplay2/IPC_Unix.cpp                      |   2 +-
 src/qmplay2/IPC_Windows.cpp                   |   2 +-
 src/qmplay2/InDockW.cpp                       |   3 +
 src/qmplay2/InDockW.hpp                       |  13 +-
 src/qmplay2/LibASS.cpp                        |   7 +-
 src/qmplay2/LibASS.hpp                        |   6 +-
 src/qmplay2/LineEdit.cpp                      |  26 +-
 src/qmplay2/LineEdit.hpp                      |  12 +-
 src/qmplay2/Module.cpp                        |   2 +-
 src/qmplay2/Module.hpp                        |   3 +-
 src/qmplay2/NetworkAccess.cpp                 |  38 +-
 src/qmplay2/NetworkAccess.hpp                 |  42 +-
 src/qmplay2/NetworkAccessJS.cpp               |  67 +-
 src/qmplay2/NetworkAccessJS.hpp               |  11 +
 src/qmplay2/NotifiesAndroid.hpp               |   6 +-
 src/qmplay2/NotifiesFreedesktop.hpp           |   6 +-
 src/qmplay2/NotifiesMacOS.hpp                 |   6 +-
 src/qmplay2/NotifiesMacOS.mm                  |  25 +
 src/qmplay2/NotifiesTray.hpp                  |   8 +-
 src/qmplay2/QMPlay2Core.cpp                   |  93 ++-
 src/qmplay2/QMPlay2Extensions.cpp             |   2 +-
 src/qmplay2/Reader.cpp                        |   2 +-
 src/qmplay2/Settings.cpp                      |   2 +-
 src/qmplay2/Slider.cpp                        |  11 +-
 src/qmplay2/Slider.hpp                        |  16 +-
 src/qmplay2/SndResampler.cpp                  |   2 +-
 src/qmplay2/StreamInfo.hpp                    |   4 +-
 src/qmplay2/StreamMuxer.cpp                   |  23 +-
 src/qmplay2/VideoFilter.cpp                   |  12 +-
 src/qmplay2/VideoFilter.hpp                   |   4 +-
 src/qmplay2/VideoFilters.cpp                  |   6 +-
 src/qmplay2/VideoOutputCommon.cpp             |  66 +-
 src/qmplay2/VideoOutputCommon.hpp             |  23 +-
 src/qmplay2/Writer.cpp                        |  20 +-
 src/qmplay2/X11BypassCompositor.cpp           |  27 +-
 src/qmplay2/X11BypassCompositor.hpp           |  10 +-
 src/qmplay2/YouTubeDL.cpp                     | 137 +++-
 src/qmplay2/YouTubeDL.hpp                     |   4 +-
 src/qmplay2/opengl/OpenGLCommon.cpp           |  69 +-
 src/qmplay2/opengl/OpenGLCommon.hpp           |  22 +-
 src/qmplay2/opengl/OpenGLInstance.cpp         | 116 +++-
 src/qmplay2/opengl/OpenGLInstance.hpp         |   8 +-
 src/qmplay2/opengl/OpenGLWidget.cpp           |  15 +-
 src/qmplay2/opengl/OpenGLWidget.hpp           |  20 +-
 src/qmplay2/opengl/OpenGLWindow.cpp           |  81 ++-
 src/qmplay2/opengl/OpenGLWindow.hpp           |  24 +-
 src/qmplay2/opengl/OpenGLWriter.cpp           |  20 +-
 src/qmplay2/opengl/OpenGLWriter.hpp           |  22 +-
 src/qmplay2/opengl/Qt4OpenGLCompat.hpp        | 248 +++++++
 src/qmplay2/opengl/shaders/OSD.frag           |   1 +
 src/qmplay2/opengl/shaders/OSD.vert           |   1 +
 src/qmplay2/opengl/shaders/Video.vert         |   1 +
 src/qmplay2/opengl/shaders/VideoRGB.frag      |   1 +
 src/qmplay2/opengl/shaders/VideoYCbCr.frag    |   1 +
 src/qmplay2/vulkan/VulkanInstance.cpp         |   4 +-
 src/qmplay2/vulkan/VulkanInstance.hpp         |  10 +-
 src/qmplay2/vulkan/VulkanWindow.cpp           |   6 +-
 src/qmplay2/vulkan/VulkanWindow.hpp           |   4 +-
 src/qmplay2/vulkan/VulkanWriter.hpp           |  20 +-
 src/qmplay2/vulkan/VulkanYadifDeint.hpp       |   4 +-
 269 files changed, 5251 insertions(+), 2498 deletions(-)
 create mode 100644 src/qmplay2/opengl/Qt4OpenGLCompat.hpp

diff --git a/CMakeLists.txt b/CMakeLists.txt
index ae8b8809..80e80e5e 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -38,16 +38,47 @@ else()
     find_package(DummyPkgConfig REQUIRED)
 endif()
 
-option(BUILD_WITH_QT6 "Build with Qt6" ON)
-add_feature_info(Qt6 BUILD_WITH_QT6 "Build with Qt6")
-
-if(BUILD_WITH_QT6)
-    set(QT_PREFIX Qt6)
-    find_package(Qt6Widgets 6.1 REQUIRED)
-    find_package(Qt6Core5Compat 6.1 REQUIRED)
+option(BUILD_WITH_QT4 "Build with Qt4 (for macOS 10.5/10.6 PowerPC compatibility)" OFF)
+add_feature_info(Qt4 BUILD_WITH_QT4 "Build with Qt4")
+
+if(BUILD_WITH_QT4)
+    set(QT_PREFIX Qt)
+    find_package(Qt4 4.8 REQUIRED QtCore QtGui QtSvg QtOpenGL QtNetwork)
+    include(${QT_USE_FILE})
+
+    if(APPLE)
+        # moc doesn't get the compiler's predefined macros (no __APPLE__),
+        # so #ifdef Q_OS_MAC guards around slots would otherwise be silently
+        # dropped from the meta-object at moc time even though the real
+        # compiler sees them fine. Feed moc the define directly instead of
+        # relying on CMAKE_AUTOMOC_COMPILER_PREDEFINES (which needs a newer
+        # CMake than some Qt4/macOS toolchains ship with).
+        add_definitions(-DQ_OS_MAC)
+    endif()
 else()
-    set(QT_PREFIX Qt5)
-    find_package(Qt5Widgets 5.15.2 REQUIRED)
+    option(BUILD_WITH_QT6 "Build with Qt6" ON)
+    add_feature_info(Qt6 BUILD_WITH_QT6 "Build with Qt6")
+
+    if(BUILD_WITH_QT6)
+        set(QT_PREFIX Qt6)
+        find_package(Qt6Widgets 6.1 REQUIRED)
+        find_package(Qt6Core5Compat 6.1 REQUIRED)
+    else()
+        set(QT_PREFIX Qt5)
+        find_package(Qt5Widgets 5.15.2 REQUIRED)
+    endif()
+endif()
+
+# Add QJson4 for JSON support (Qt4 doesn't have native JSON)
+# QJson4 library from https://github.com/eteran/qjson4
+set(QJSON4_INCLUDE_DIR "" CACHE PATH "Path to QJson4 headers")
+if(QJSON4_INCLUDE_DIR)
+    include_directories(${QJSON4_INCLUDE_DIR})
+    add_definitions(-DUSE_QJSON4)
+    set(QJSON4_LIBRARY QJson4)
+    message(STATUS "QJson4 enabled: headers at ${QJSON4_INCLUDE_DIR}")
+elseif(BUILD_WITH_QT4)
+    message(WARNING "QJSON4_INCLUDE_DIR not set. Qt4 builds require QJson4 from https://github.com/eteran/qjson4")
 endif()
 
 pkg_check_modules(LIBAVFORMAT REQUIRED libavformat>=58.12.100)
@@ -62,7 +93,16 @@ set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-set(CMAKE_AUTOMOC_COMPILER_PREDEFINES OFF)
+if(BUILD_WITH_QT4)
+    # Qt4: give moc the compiler's real predefines (e.g. __APPLE__) so
+    # #ifdef Q_OS_MAC guards around slots resolve the same way for moc as
+    # for the real compiler (see the explicit add_definitions(-DQ_OS_MAC)
+    # above as a belt-and-suspenders fallback: this CMake feature requires
+    # a fairly recent CMake and silently no-ops on older ones).
+    set(CMAKE_AUTOMOC_COMPILER_PREDEFINES ON)
+else()
+    set(CMAKE_AUTOMOC_COMPILER_PREDEFINES OFF)
+endif()
 
 option(USE_PCH "Use precompiled headers" OFF)
 add_feature_info(PCH USE_PCH "Use precompiled headers")
@@ -92,9 +132,10 @@ endif()
 
 add_definitions(-D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DQT_USE_QSTRINGBUILDER)
 
-if (BUILD_WITH_QT6)
+if(BUILD_WITH_QT6)
     add_definitions(-DQ_ENTER_EVENT=QEnterEvent)
 else()
+    # Qt4 uses QEvent for enter events
     add_definitions(-DQ_ENTER_EVENT=QEvent)
 endif()
 
@@ -111,28 +152,41 @@ option(USE_OPENGL "Build with OpenGL support" ON)
 add_feature_info(OpenGL USE_OPENGL "Build with OpenGL support")
 if(USE_OPENGL)
     add_definitions(-DUSE_OPENGL)
-    if(BUILD_WITH_QT6)
+    if(BUILD_WITH_QT4)
+        # Qt4 has OpenGL support built into QtOpenGL module (already required above)
+        # Limiting to OpenGL 2.0 for macOS 10.6.8 compatibility
+        add_definitions(-DMAX_OPENGL_VERSION=2.0)
+    elseif(BUILD_WITH_QT6)
         find_package(Qt6OpenGL REQUIRED)
         find_package(Qt6OpenGLWidgets REQUIRED)
     endif()
 endif()
 
-if(NOT APPLE)
-    if (BUILD_WITH_QT6)
-        get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui QT_ENABLED_PUBLIC_FEATURES)
-    else()
-        get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui INTERFACE_QT_ENABLED_FEATURES)
+if(BUILD_WITH_QT4)
+    # Vulkan is not supported on macOS 10.6.8 and not available in Qt4
+    set(USE_VULKAN OFF)
+    add_feature_info(Vulkan USE_VULKAN "Build with Vulkan support (disabled for Qt4/macOS 10.6.8)")
+
+    # GLSLC is only needed for Vulkan shader compilation (not used in Qt4 build)
+    set(USE_GLSLC OFF)
+else()
+    if(NOT APPLE)
+        if (BUILD_WITH_QT6)
+            get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui QT_ENABLED_PUBLIC_FEATURES)
+        else()
+            get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui INTERFACE_QT_ENABLED_FEATURES)
+        endif()
+        list(FIND ${QT_PREFIX}GuiFeatures "vulkan" ${QT_PREFIX}Vulkan)
+        if(${${QT_PREFIX}Vulkan} GREATER -1)
+            set(VULKAN_AVAILABLE ON)
+        endif()
     endif()
-    list(FIND ${QT_PREFIX}GuiFeatures "vulkan" ${QT_PREFIX}Vulkan)
-    if(${${QT_PREFIX}Vulkan} GREATER -1)
-        set(VULKAN_AVAILABLE ON)
+    option(USE_VULKAN "Build with Vulkan support" ${VULKAN_AVAILABLE})
+    add_feature_info(Vulkan USE_VULKAN "Build with Vulkan support")
+    if(USE_VULKAN)
+        add_definitions(-DUSE_VULKAN)
     endif()
 endif()
-option(USE_VULKAN "Build with Vulkan support" ${VULKAN_AVAILABLE})
-add_feature_info(Vulkan USE_VULKAN "Build with Vulkan support")
-if(USE_VULKAN)
-    add_definitions(-DUSE_VULKAN)
-endif()
 
 if(NOT WIN32 AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
     option(USE_FREEDESKTOP_NOTIFICATIONS "Use Freedesktop notifications" ON)
@@ -158,8 +212,14 @@ option(USE_EXTENSIONS "Build with Extensions module" ON)
 add_feature_info(Extensions USE_EXTENSIONS "Build with Extensions module")
 
 if(USE_EXTENSIONS)
-    option(USE_MEDIABROWSER "Build with MediaBrowser support" ON)
-    add_feature_info(MediaBrowser USE_MEDIABROWSER "Build with MediaBrowser support")
+    if(BUILD_WITH_QT4)
+        # MediaBrowser requires QtQml which is not available in Qt4
+        set(USE_MEDIABROWSER OFF)
+        add_feature_info(MediaBrowser USE_MEDIABROWSER "Build with MediaBrowser support (disabled - requires Qt5+)")
+    else()
+        option(USE_MEDIABROWSER "Build with MediaBrowser support" ON)
+        add_feature_info(MediaBrowser USE_MEDIABROWSER "Build with MediaBrowser support")
+    endif()
 
     option(USE_LASTFM "Build with LastFM support" ON)
     add_feature_info(LastFM USE_LASTFM "Build with LastFM support")
@@ -215,14 +275,20 @@ endif()
 option(USE_TAGLIB "Build with tags editor" ${TAGLIB_FOUND})
 add_feature_info(TagLib USE_TAGLIB "Build with tags editor")
 
-if(NOT DEFINED LIBAVUTIL_VERSION)
-    set(LIBAVUTIL_VERSION "58.29.100")
-endif()
-if(NOT DEFINED USE_FFMPEG_VKVIDEO AND USE_VULKAN AND ${LIBAVUTIL_VERSION} VERSION_GREATER_EQUAL "58.29.100")
-    set(DEFAULT_USE_FFMPEG_VKVIDEO ON)
+if(BUILD_WITH_QT4)
+    # VkVideo requires Vulkan which is disabled for Qt4/macOS 10.6.8
+    set(USE_FFMPEG_VKVIDEO OFF)
+    add_feature_info(VkVideo USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg (disabled for Qt4)")
+else()
+    if(NOT DEFINED LIBAVUTIL_VERSION)
+        set(LIBAVUTIL_VERSION "58.29.100")
+    endif()
+    if(NOT DEFINED USE_FFMPEG_VKVIDEO AND USE_VULKAN AND ${LIBAVUTIL_VERSION} VERSION_GREATER_EQUAL "58.29.100")
+        set(DEFAULT_USE_FFMPEG_VKVIDEO ON)
+    endif()
+    option(USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg" ${DEFAULT_USE_FFMPEG_VKVIDEO})
+    add_feature_info(VkVideo USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg")
 endif()
-option(USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg" ${DEFAULT_USE_FFMPEG_VKVIDEO})
-add_feature_info(VkVideo USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg")
 
 if(NOT DEFINED USE_FFMPEG_VAAPI)
     pkg_check_modules(LIBS_VAAPI libva>=1.1.0 libva-drm)
@@ -298,11 +364,22 @@ add_feature_info(PipeWire USE_PIPEWIRE "Build with PipeWire module")
 if(NOT DEFINED USE_XVIDEO)
     pkg_check_modules(LIB_X11_XV x11 xv)
 endif()
-option(USE_XVIDEO "Build with XVideo module" ${LIB_X11_XV_FOUND})
-add_feature_info(XVideo USE_XVIDEO "Build with XVideo module")
+if(BUILD_WITH_QT4)
+    option(USE_XVIDEO "Build with XVideo module" OFF)
+    add_feature_info(XVideo USE_XVIDEO "Build with XVideo module (disabled for Qt4 build)")
+else()
+    option(USE_XVIDEO "Build with XVideo module" ${LIB_X11_XV_FOUND})
+    add_feature_info(XVideo USE_XVIDEO "Build with XVideo module")
+endif()
 
-option(USE_CUVID "Build with CUVID module" ${DEFAULT_CUVID})
-add_feature_info(CUVID USE_CUVID "Build with CUVID module")
+if(BUILD_WITH_QT4)
+    # CUVID (NVIDIA) is not available on PowerPC macOS
+    set(USE_CUVID OFF)
+    add_feature_info(CUVID USE_CUVID "Build with CUVID module (disabled for PowerPC)")
+else()
+    option(USE_CUVID "Build with CUVID module" ${DEFAULT_CUVID})
+    add_feature_info(CUVID USE_CUVID "Build with CUVID module")
+endif()
 
 option(USE_NOTIFY "Build additional notifications module" ON)
 add_feature_info(Notifications USE_NOTIFY "Build additional notifications module")
@@ -420,16 +497,29 @@ if(NOT WIN32 AND NOT APPLE)
     set(SOLID_ACTIONS_INSTALL_PATH ${SOLID_ACTIONS_DEFAULT} CACHE STRING "The destination path for the Solid actions (\"None\" to disable)")
 endif()
 
-if(USE_FREEDESKTOP_NOTIFICATIONS OR USE_DBUS_PM OR USE_MPRIS2)
-    find_package(${QT_PREFIX}DBus REQUIRED)
-endif()
+if(BUILD_WITH_QT4)
+    # Qt4 has DBus support in QtDBus module (already included if needed)
+    # Note: DBus features are primarily for Linux, not macOS 10.6.8
+    if(USE_FREEDESKTOP_NOTIFICATIONS OR USE_DBUS_PM OR USE_MPRIS2)
+        message(STATUS "DBus support requested but may not be needed for macOS build")
+    endif()
 
-if(USE_MEDIABROWSER)
-    find_package(${QT_PREFIX}Qml REQUIRED)
-    set(USE_QML ON)
-endif()
+    # MediaBrowser is disabled for Qt4 (requires QtQml)
+    set(USE_QML OFF)
 
-find_package(${QT_PREFIX}Svg REQUIRED)
+    # QtSvg is already required in find_package(Qt4) above
+else()
+    if(USE_FREEDESKTOP_NOTIFICATIONS OR USE_DBUS_PM OR USE_MPRIS2)
+        find_package(${QT_PREFIX}DBus REQUIRED)
+    endif()
+
+    if(USE_MEDIABROWSER)
+        find_package(${QT_PREFIX}Qml REQUIRED)
+        set(USE_QML ON)
+    endif()
+
+    find_package(${QT_PREFIX}Svg REQUIRED)
+endif()
 
 if(USE_VULKAN)
     set(Vulkan_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/src/qmplay2/vulkan/headers/include")
diff --git a/lang/CMakeLists.txt b/lang/CMakeLists.txt
index b4e82ec3..8aee69e9 100644
--- a/lang/CMakeLists.txt
+++ b/lang/CMakeLists.txt
@@ -12,9 +12,15 @@ else()
     endforeach()
 endif()
 
-find_package(${QT_PREFIX} REQUIRED COMPONENTS LinguistTools)
+# Qt4 doesn't have LinguistTools as a separate component
+if(NOT BUILD_WITH_QT4)
+    find_package(${QT_PREFIX} REQUIRED COMPONENTS LinguistTools)
+endif()
+
 if(BUILD_WITH_QT6)
     qt6_add_translation(QM_FILES ${QMPLAY2_TSS})
+elseif(BUILD_WITH_QT4)
+    qt4_add_translation(QM_FILES ${QMPLAY2_TSS})
 else()
     qt5_add_translation(QM_FILES ${QMPLAY2_TSS})
 endif()
diff --git a/src/gui/AVThread.cpp b/src/gui/AVThread.cpp
index e2a14f8f..5e44f755 100644
--- a/src/gui/AVThread.cpp
+++ b/src/gui/AVThread.cpp
@@ -26,6 +26,9 @@
 
 AVThread::AVThread(PlayClass &playC)
     : playC(playC)
+#if QT_VERSION < QT_VERSION_CHECK(5, 14, 0)
+    , mutex(QMutex::Recursive)
+#endif
 {
     connect(this, SIGNAL(finished()), this, SLOT(deleteLater()));
     mutex.lock();
diff --git a/src/gui/AVThread.hpp b/src/gui/AVThread.hpp
index b96d4f56..bbb6bd27 100644
--- a/src/gui/AVThread.hpp
+++ b/src/gui/AVThread.hpp
@@ -22,6 +22,9 @@
 #include <QStringList>
 #include <QThread>
 #include <QMutex>
+#if QT_VERSION >= 0x050E00
+    #include <QRecursiveMutex>
+#endif
 
 #include <atomic>
 
@@ -31,7 +34,7 @@ class Writer;
 
 class AVThread : public QThread
 {
-    Q_DECLARE_TR_FUNCTIONS(AVThread)
+    Q_OBJECT
 
 public:
     virtual void setDec(Decoder *_dec);
@@ -73,6 +76,10 @@ protected:
 
     std::atomic_bool br = false, br2 = false;
     bool waiting = false;
+#if QT_VERSION >= 0x050E00
     QRecursiveMutex mutex;
+#else
+    QMutex mutex;
+#endif
     QMutex updateMutex;
 };
diff --git a/src/gui/AboutWidget.cpp b/src/gui/AboutWidget.cpp
index 0084cb46..c7c09a83 100644
--- a/src/gui/AboutWidget.cpp
+++ b/src/gui/AboutWidget.cpp
@@ -33,7 +33,7 @@
 #include <QMouseEvent>
 #include <QMessageBox>
 #include <QPlainTextEdit>
-#include <QGuiApplication>
+#include <QApplication>
 #include <QDesktopServices>
 
 AboutWidget::AboutWidget()
@@ -44,9 +44,14 @@ AboutWidget::AboutWidget()
     QString labelText;
     labelText += "<b>QMPlay2:</b> " + tr("video and audio player");
     labelText += "<br/><b>" + tr("Programmer") + ":</b> <a href='mailto:mumei6102@gmail.com'>Błażej Szczygieł</a>";
+#if QT_VERSION >= QT_VERSION_CHECK(5, 4, 0)
     labelText += "<br/><b>" + tr("Version") + ":</b> " + Version::get() + " (" + QSysInfo::buildCpuArchitecture();
-#if !defined(Q_OS_MACOS) && !defined(Q_OS_WIN)
-    labelText += ", " + QGuiApplication::platformName();
+#else
+    // Qt4: QSysInfo::buildCpuArchitecture() doesn't exist
+    labelText += "<br/><b>" + tr("Version") + ":</b> " + Version::get() + " (";
+#endif
+#if !defined(Q_OS_MAC) && !defined(Q_OS_WIN)
+    labelText += ", " + QApplication::platformName();
 #endif
     labelText += ")";
     labelText += "<br/><br/><a href='https://github.com/zaps166/QMPlay2/releases/latest'>" + tr("GitHub download page") + "</a>";
@@ -60,7 +65,14 @@ AboutWidget::AboutWidget()
 
     QTabWidget *tabW = new QTabWidget;
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
     const QFont font(QFontDatabase::systemFont(QFontDatabase::FixedFont));
+#else
+    // Qt4: QFontDatabase::systemFont() doesn't exist, use a monospace font
+    QFont font;
+    font.setFamily("Courier");
+    font.setStyleHint(QFont::TypeWriter);
+#endif
 
     logE = new QPlainTextEdit;
     logE->setFont(font);
diff --git a/src/gui/AboutWidget.hpp b/src/gui/AboutWidget.hpp
index abc800c5..92c17bf0 100644
--- a/src/gui/AboutWidget.hpp
+++ b/src/gui/AboutWidget.hpp
@@ -24,14 +24,14 @@
 class QPlainTextEdit;
 class QPushButton;
 
-class AboutWidget final : public QWidget
+class AboutWidget : public QWidget
 {
     Q_OBJECT
 public:
     AboutWidget();
 private:
-    void showEvent(QShowEvent *) override;
-    void closeEvent(QCloseEvent *) override;
+    void showEvent(QShowEvent *);
+    void closeEvent(QCloseEvent *);
 
     QPlainTextEdit *logE, *clE, *auE;
     QPushButton *clrLogB;
diff --git a/src/gui/AddressBox.cpp b/src/gui/AddressBox.cpp
index 4e400b91..449b5e1f 100644
--- a/src/gui/AddressBox.cpp
+++ b/src/gui/AddressBox.cpp
@@ -23,7 +23,7 @@
 #include <Module.hpp>
 #include <Main.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QGridLayout>
 #include <QClipboard>
 #include <QDir>
@@ -55,7 +55,7 @@ AddressBox::AddressBox(Qt::Orientation o, QString url, const QString &choice)
 
     if (url.isNull())
     {
-        const auto text = QGuiApplication::clipboard()->text();
+        const auto text = QApplication::clipboard()->text();
         if (text.contains("://") && text.indexOf("://") == text.indexOf(":") && QUrl(text).isValid())
             url = text;
     }
diff --git a/src/gui/AddressDialog.hpp b/src/gui/AddressDialog.hpp
index 314973de..c8c7fe33 100644
--- a/src/gui/AddressDialog.hpp
+++ b/src/gui/AddressDialog.hpp
@@ -24,7 +24,7 @@
 #include <QCheckBox>
 #include <QDialog>
 
-class AddressDialog final : public QDialog
+class AddressDialog : public QDialog
 {
     Q_DECLARE_TR_FUNCTIONS(AddressDialog)
 public:
